
/*===========================================
LEGACY STUFF
============================================= */
    /** Navbar active links
    $(function() {
      function getPageName(url) {
        url = url.split("/");
        url = url[url.length - 1];
        url = url.split("#");
        url = url[0];
        return url;
      }

      var currentUrl = window.location.href;
      var pageName = getPageName(currentUrl);

      $(".navbar-nav li > a[href$='" + pageName + "']").parent("li").first()
        .addClass("active");

      $(".navbar-nav > li").has(".active").first()
        .addClass("active");
    });*/

    /** Search Form Focus **/
    $('#search-toggle').on('shown.bs.dropdown', () => $("#search-input").focus());
    /** Search Form reset on close **/
    //$('#search-toggle').on('hidden.bs.dropdown', () => $("#search-input").val(""));

    /** Smooth scroll to anchor **/
    $(function() {
      $("a[href*='#']").not("[href='#'], [data-toggle], [data-slide]").click(function() {
        if (location.pathname.replace(/^\//,'') == this.pathname.replace(/^\//,'') && location.hostname == this.hostname) {
          var target = $(this.hash);
              target = target.length ? target : $('[name=' + this.hash.slice(1) +']');

          if (target.length) {
            $('html,body').animate({
              scrollTop: (target.offset().top + 50)
            }, 1000);

            return false;
          }
        }
      });
    });



/*===========================================
DESIGN
============================================= */
    /* NAV ResizeObserver: Add body top-margin if Main Nav Bar content wraps */
    const ro = new ResizeObserver(entries => {
      for (let entry of entries) {
        //Check if the Main Nav Bar is > 40px and add/remove class to body
        if (entry.contentRect.height > 40) {
            $('body').addClass("main_nav_large");
        } else {
            $('body').removeClass("main_nav_large");
        }

      }
    });
    ro.observe(document.querySelector('#main_nav'));

    /* Sticky Content Bar Observer */
    if ($('#contentbar').length > 0) {
        const el = document.getElementById("contentbar")
        const io = new IntersectionObserver( 
        ([e]) => e.target.classList.toggle("floating", e.isIntersecting),
        { threshold: [1], root: document.getElementById('content-container'), rootMargin: '-83px 0px 0px 0px' }
        );
        io.observe(el);    
    }
 
    //Detect if the navbar is expanded. Cant believe I have to do it like this, but oh well..    
    addNavbarExpandedClass();
    function addNavbarExpandedClass() {
        if ($(this).width() < 992) {
            $('#main_nav').addClass('notExpanded');
        } else {
            $('#main_nav').removeClass('notExpanded');
        }
    }
    $(window).resize(function() {
        addNavbarExpandedClass();
    });
    
    

    /* Autohide Navbar */
    // $("#main_nav").autoHidingNavbar({showOnBottom: false, animationDuration: 450, hideOffset: 320});
    // $("#main_nav").on("hide.autoHidingNavbar", function() {
    //     //Hide Dropdows Menus on Hide
    //     $('#main_nav .dropdown-toggle.show').dropdown('toggle');
    //     //Animate Sidebar to move with the Navbar on Hide
    //     $(".floaty").animate({
    //     top: "-=60px",
    //     }, '450ms' );
    // });
    // $("#main_nav").on("show.autoHidingNavbar", function() {
    //    //Animate Sidebar to move with the Navbar on Show
    //     $(".floaty").animate({
    //     top: "+=60px",
    //     }, '450ms' );
    // });

    /* Color Switcher - Remove at some point */
    function color_switch(nr) {
       let color_sets = {
         0: {
        'primary_color':         '#b77686',
        'secondary_color':       '#97ccbf',
        'secondary_color_light': '#bde8de',
        'secondary_color_dark':  '#bde8de',
        'link_color':            '#ca4c6b',
        'grey_color':            '#edf1f0',
         },
         1: {
        'primary_color':         '#444444',
        'secondary_color':       '#97ccbf',
        'secondary_color_light': '#bde8de',
        'secondary_color_dark':  '#bde8de',
        'link_color':            '#a885b7',
        'grey_color':            '#edf1f0',
         },
         2: {
        'primary_color':         '#2d5669',
        'secondary_color':       '#a98a7c',
        'secondary_color_light': '#847066',
        'secondary_color_dark':  '#96786a',
        'link_color':            '#d66937',
        'grey_color':            '#f1ebe8',
         },
         3: {
        'primary_color':         '#54618e',
        'secondary_color':       '#99c8d6',
        'secondary_color_light': '#78aab9',
        'secondary_color_dark':  '#83aebb',
        'link_color':            '#e66533',
        'grey_color':            '#edf1f0',

         },
         4: {
        'primary_color':         '#849DBF',
        'secondary_color':       '#98abb5',
        'secondary_color_light': '#bacee8',
        'secondary_color_dark':  '#bacee8',
        'link_color':            '#5F87BF',
        'grey_color':            '#bacee8',
         },
         5: {
        'primary_color':         '#bf8484',
        'secondary_color':       '#84bfbf',
        'secondary_color_light': '#a1d8d8',
        'secondary_color_dark':  '#a1d8d8',
        'link_color':            '#da9292',
        'grey_color':            '#f1f1f1',
         }
     };
     $(':root').get(0).style.setProperty("--primary-color", color_sets[nr].primary_color);
     $(':root').get(0).style.setProperty("--secondary-color", color_sets[nr].secondary_color);
     $(':root').get(0).style.setProperty("--secondary-color-light", color_sets[nr].secondary_color_light);
     $(':root').get(0).style.setProperty("--secondary-color-dark", color_sets[nr].secondary_color_dark);
     $(':root').get(0).style.setProperty("--link-color", color_sets[nr].link_color);
     $(':root').get(0).style.setProperty("--grey-color", color_sets[nr].grey_color);
    }


/**
 * Convenience function to get the value of a specific
 * query parameter from the current URL
 * @returns {string}
 */
function getQueryParamFromURL(param){
    let queryParams = new URLSearchParams(window.location.search);
    if (queryParams.has(param)){
        return queryParams.get(param);
    } else {
        return undefined;
    }
}


/**
 * Detect and return the current active responsive breakpoint in Bootstrap
 * @returns {string}
 * @author farside {@link https://stackoverflow.com/users/4354249/farside}
 */
function getResponsiveBreakpoint(smallerThanEnv = 0) {
    var envs = ["xs", "sm", "md", "lg", "xl"];
    var env = "";

    var $el = $("<div>");
    $el.appendTo($("body"));

    for (var i = envs.length - 1; i >= 0; i--) {
        env = envs[i];
        $el.addClass("d-" + env + "-none");
        if ($el.is(":hidden")) {
            break; // env detected
        }
    }
    $el.remove();

    if (smallerThanEnv) {
        if (envs.indexOf(smallerThanEnv) < envs.indexOf(env)) {
            return true;
        } else {
            return false;
        }
    }
    return env;
}


/*===========================================
LOAD AND SORT CONTENT
============================================= */

let getUrl     = window.location;
let baseUrl    = getUrl .protocol + "//" + getUrl.host;
var sadeditUrl = baseUrl+'/sadedit';

var docsUrl    = sadeditUrl+'/api/docs';
var searchUrl  = sadeditUrl+'/api/search';

var content_list_global  = [];
var sort_dir             = '';
var sort_by              = '';

var isSearch = false;


/*===========================================
AFTER PAGE LOAD
============================================= */

$(document).ready(() => {

    //// LOAD DOCUMENT FROM SADEDIT

    //Load Search Results
    if ($('#content_list').length > 0 && $('#content_list').data('category') == 'search') {

        isSearch = true;

        //Get search param
        const searchStr = getQueryParamFromURL('q');

        fetch(searchUrl+'?q='+searchStr+'&page_len=9999', {
            method: 'GET',
            headers: {
                'Content-Type': 'application/json'
            }
        })
            .then((response) => response.json())
            .then((search_results) => process_search_results(search_results))
            .then((hits_json) => sort_content(hits_json))
            .then((hits_json_sorted) => post_content(hits_json_sorted))
            .then(() => build_content_list_addons())

        .catch(function(error) {
            console.log(error);
        });
    //OR Load Content List
    } else if ($('#content_list').length > 0) {
        fetch(docsUrl, {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json'
            },body: JSON.stringify({})

        })
            .then((response) => response.json())
            .then((content_json) => filter_content_list(content_json.docs))
            .then((content_json_filtered) => filter_content_list_by_lang(content_json_filtered))
            .then((content_json_filtered) => sort_content(content_json_filtered))
            .then((content_json_filtered_sorted) => post_content(content_json_filtered_sorted))
            .then(() => build_content_list_addons())
        .catch(function(error) {
            console.log(error);
        });
    //OR Load Single Document
    } else if ($('#doc_content'.length > 0)) {
        let id = getQueryParamFromURL('id');
        if(id !== undefined) {

            $('#doc_content').data('id', id);

            $.ajax({
                url: sadeditUrl+"/api/doc",
                data: JSON.stringify({id: id, content: "html"}),
                contentType: "application/json",
                method: "POST",
                success: async (data) => {
                    const docHtml = preprocessDocContent(data.html);
                    await $('#doc_content').append(docHtml);
                    //Lazy Images
                    $('#doc_content img').Lazy({
                        effect: 'fadeIn',
                        effectTime: 100
                    });                    
                    //Legacy, only needed for some older documents: Add id to Footnotes-Heading
                    let footnotesH = $('h1:contains("Footnotes"), h2:contains("Footnotes"), h3:contains("Footnotes")');
                    $(footnotesH[0]).attr('id', 'footnotes');
                    //Change Page title
                    document.title = data.title;
                    buildPageStructure();
                }
            })
        }
    }

    //// DISPLAY CURRENT LANGUAGE SELECTION
    let langParam = getQueryParamFromURL('lang');
    let lang = langParam === undefined ? $('#current_lang lang').text().toLowerCase() : langParam;
    $(`#i18n-dropdown li[data-lang="${lang}"]`).hide();
});

function preprocessDocContent(docHtml) {

    //Hide DOIs for now
    //docHtml = docHtml.replace(/<p>DOI.+<\/p>/g, '<p style="color: var(--link-color)"> DOIs currently being updated </p>');

    //Add image onClick
    docHtml = docHtml.replace(/(<img.+?)(>)/g, "$1 onClick=\"loadImgModal(this)\" $2");

    //Append Img Modal
    docHtml += '<div class="modal fade" id="img-modal"><div class="modal-dialog modal-dialog-centered modal-xl"><div class="modal-content"><div class="modal-header"><button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button></div><div class="modal-body"></div></div></div></div>';

    //Lazy Loading imgs
    docHtml = docHtml.replace(/src=/g, ' data-src=');
    return docHtml;
}

function getTranslation(name) {
    return $('#trans-'+name).text().trim();
}

function loadImgModal(img) {

    const altTxt = $(img).attr('alt');
    const fileName = $(img).attr('src').split("/").pop();
    const url = sadeditUrl+'/uploads/original/'+fileName;
    $('#img-modal .modal-body').html('<a href="'+url+'" title="Open in new window" target="_blank"><img src="'+url+'" alt="'+altTxt+'" /></a>');

    var imgModal = document.querySelector('#img-modal');
    var modalInst = bootstrap.Modal.getOrCreateInstance(imgModal);
    modalInst.show();


}

function buildPageStructure() {

    let headings = $('h1,h2,h3,h4,h5,h6').not('#site-header');
    let structure = '';
    if (headings.length > 1) {
        headings.each((key, heading) => {
            //The footnotes header needs to stay the way it is for the footnotes links to work
            //Set Heading IDs for Linking
            let id = $(heading).attr('id');
            if (!($(heading).is('#footnotes') || $(heading).is('#footnotes-overview'))) {
                const txt = encodeURIComponent($(heading).text().replace(/\s/g, "_"));
                id  = 'heading-'+txt;
                $(heading).attr('id', id);
            }

            //Build structure
            structure += `<a class="structure-link structure-${heading.tagName}" href="#${id}">${heading.textContent}</a>`;
        });
        $('#doc_structure-content').html(structure);
        $('#structure-btn').show();
    }
}
function toggleStructure() {
    $('#doc_structure-content').toggle(150);
}

async function initPrint() {
    loadAllLazyImages().then(() => $('#doc_content').print({stylesheet:'res/css/print.css'}));
}

async function loadAllLazyImages() {
    const promises = [];
    
    var instance = $('#doc_content img').Lazy({chainable: false, onError: (img) => {
        //This seems to be nessecary: By default Lazy doesnt update the src attribute if the data-src gives a 404. Thus no error is thrown and the onerror-function doesnt trigger.
        //So we are updating the src-attribute manually even if a 404 is recieved by Lazy
        $(img).removeAttr("src");
        $(img).attr('src', $(img).data('data-src'));
    }});
   
    //Select only not-loaded images (those that have the data-src-attribute anymore)
    //And wait for them to be loaded (or have an error)
    $('#doc_content img[data-src]').each((key, img) => {    
        promises.push(new Promise((resolve, reject) => {
            img.onerror = resolve;
            img.onload  = resolve;
            instance.force($(img));
            
        }));
    });
    await Promise.all(promises);
    return true;     
}

function process_search_results(search_results) {
    //Some stuff might happen here in the future

    window.content_list_global = search_results.hits;
    return search_results.hits;
}

function filter_content_list(content_list) {

    //Filter Content List: Only content matching the #content_list category is to be displayed
    let filtered_and_sorted_content_list = [];

    let include_filter = $('#content_list').data('category');
    let exclude_filter = $('#content_list').data('category_exclude');

    //First Check for and apply Exclude-Filter
    if (exclude_filter !== undefined && exclude_filter.length > 0) {
        exclude_filter = exclude_filter.split(',');
        $(content_list).each(function(index, item) {
            if (Array.isArray(item.category)) {
                item.category.forEach((cat, cat_index) => {
                    if (exclude_filter.indexOf(cat) == -1) {
                        filtered_and_sorted_content_list.push(item);
                    }
                });
            } else {
                if (exclude_filter.indexOf(item.category) == -1) {
                    filtered_and_sorted_content_list.push(item);
                }
            }
        });
    //Only if no Exclude-Filter is set, the include filter is applied
    } else if (include_filter !== undefined && include_filter.length > 0) {
        include_filter = include_filter.split(',');
        $(content_list).each(function(index, item) {
            if (Array.isArray(item.category)) {
                item.category.forEach((cat, cat_index) => {
                    if (include_filter.indexOf(cat) > -1) {
                        filtered_and_sorted_content_list.push(item);
                    }
                });
            } else {
                if (include_filter.indexOf(item.category) > -1) {
                    filtered_and_sorted_content_list.push(item);
                }
            }
        });
    //No Filter set at all? Use all content
    } else {
       filtered_and_sorted_content_list = content_list;
    }

    //Save Filtered Content List to the document in order to not have to re-request and filter it each time the content is resorted/refiltered
    window.content_list_global = filtered_and_sorted_content_list;
    return filtered_and_sorted_content_list;
}


function filter_content_list_by_lang(content_list) {
    
    //This is now only wanted for the Team Page
    if ($('#content_list').data('category') !== 'Team') {
        return;
    }

    let lang = getQueryParamFromURL('lang');

    let lang_filtered_content_list = [];
    if (lang !== undefined) {
        lang = lang.toLowerCase();
        $(content_list).each(function(index, item) {
            if (item.language !==  undefined && item.language.toLowerCase() == lang) {
               lang_filtered_content_list.push(item);
            }
        });  
        return lang_filtered_content_list;  
    } else {
        return content_list;
    }  
}


/* Applies Sorting to content_list. */
function sort_content(content_json = [], sort_by = 'created', sort_dir = 'desc', calledByBtn = false ) {

    //If no content_list was passed, get the content list saved in the document
    if (content_json.length < 1) {
        content_json = content_list_global;
    }

    //if we are displaying search results, sort by relevance by default
    if (isSearch && !calledByBtn) {
        sort_by = 'score';
    }

    //Save the current sort to the document in order to be able to preserve sort order while applying filters
    window.sort_by  = sort_by;
    window.sort_dir = sort_dir;

    //Sort content list by given property and direction
    content_json.sort( function(a, b) {
        a[sort_by] = a[sort_by] === undefined ? "" : a[sort_by];
        b[sort_by] = b[sort_by] === undefined ? "" : b[sort_by];
        let val = a[sort_by] > b[sort_by] ? 1 : -1 ;
        val = sort_dir == 'asc' ? val : val*-1;

        return val;
    });

    return content_json;
}


function post_content (filtered_and_sorted_content_list) {

    //Any Tags to be excluded for the displayed items?
    let tags_exclude      = $('#content_list').data('tags_exclude');
    if (tags_exclude !== undefined) {
        tags_exclude = tags_exclude.split(',');
    } else {
        tags_exclude = [];
    }

    //No Search results? Dont continue;
    if (filtered_and_sorted_content_list.length == 0 && isSearch) {
        $('#search_no-results').removeClass('d-none');
        return false;
    }
    
    let items_per_page = $('#content_list').data('items_per_page') !== undefined ? $('#content_list').data('items_per_page') : 20;

    if ($('.pagination_container').length > 0) {
        //Build Pages and Pager
        $('.pagination_container').pagination({
            dataSource: filtered_and_sorted_content_list,
            ulClassName: 'pagination',
            classPrefix : 'page',
            pageSize: items_per_page,
            pageRange: 1,
            callback: function(data, pagination) {
                post_content_list_page(data, tags_exclude, 100);
            }
        });
    } else {
       post_content_list_page(filtered_and_sorted_content_list, tags_exclude, items_per_page);
    }

    return true;

}

function post_content_list_page(data, tags_exclude, max_count = 100) {

    let content_page_html = '';
    let content_list_type = $('#content_list').data('list_type');
    let excerpt_length    = $('#content_list').data('excerpt_length');

    let item_count = 0;
    //For each Content Item
    $(data).each(function(index, item){

        //Check if max_item_count is reached, if so, return
        if (item_count == max_count) {
            return content_page_html;
        }
        item_count++;

        //Build the content Item HTML and add it to the page html
        if (content_list_type == 'grid') {
            content_page_html += build_content_list_item_grid(item);
        }else if (content_list_type == 'light') {
            content_page_html += build_content_list_item_light(item);
        }else if (content_list_type == 'small_cards') {
            content_page_html += build_content_list_item(item, tags_exclude, 'col-12 col-md-6 col-lg-4', excerpt_length, false);
        }else {
            content_page_html += build_content_list_item(item, tags_exclude, excerpt_length);
        }
    });


    //Fade out the content list containing the current page itmes
    $('#content_list').animate({opacity: 0}, 300, function() {

        //Remove Masonry functionality (of the grid content lists current page) in order to recreate it on the new page
        if ($('#content_list.grid.masonry').length > 0) {
            $('#content_list.grid').masonry('destroy');
        }

        //Then insert new page items
        $('#content_list').html(content_page_html);

        //Add Masonry functionality to the grid content lists new page
        $('#content_list.grid').masonry({ "percentPosition": true, "itemSelector": '.grid-item' }).addClass('masonry');

        let loaded_images = 0;
        let total_images  = $('#content_list img').length;

        $('#content_list').animate({opacity: 1}, 300);
        $('#content_list .lazy').Lazy({
            effect: 'fadeIn',
            effectTime: 100
        });

    });


}

function build_content_list_item(item, tags_exclude, col_classes = false, excerpt_length = false, show_image = true) {

    let item_html = '';

    //Col?
    if (col_classes) {
        item_html += `<div class="${col_classes} content_list_col">`
    }
    
        //Card & body row Open
        item_html += '\
            <a href="doc.html?id='+item.id+'">\
            <div class="card my-3 content_card"><div class="row g-0">';

                //Image?
                let add_img = false;
                if (show_image && item.hasOwnProperty('previewUrl') && item.previewUrl !== '') {
                    item_html += '<div class="col-lg-7 col-xl-8">';
                    add_img = true;
                }
                //Limit Excerpt Length
                if (excerpt_length && item.teaser.length > excerpt_length) {
                    item.teaser = item.teaser.slice(0,excerpt_length)+'...';
                }

                    //Post Body Open&Close, Post Footer Open
                    item_html += '<div class="card-body">';

                        if (item.hasOwnProperty('title')) {
                            item_html += '<h5 class="card-title">'+escapeHtml(item.title);
                        }

                        //Authors
                        if (tags_exclude.indexOf('authors') < 0 && item.hasOwnProperty('authors') && item.authors !== '') {
                            item_html += '<div class="content_list-authors mt-1"><i class="material-icons">person</i>';
                            item_html += buildAuthorsList(item.authors);
                            item_html += '</div>';
                        }

                        item_html +='</h5>';

                        //For Search Results: Display Highlights instead of teaser
                        if (item.hasOwnProperty('highlights')) {
                            item_html += '<span class="txt">'+item.highlights+'</span>';
                        }
                        else if (item.hasOwnProperty('teaser')) {
                            item_html += '<span class="txt">'+item.teaser+'</span>';
                        }
                    item_html += '</div>';

                //Image?
                item_html += add_img  ? '</div><div class="col-lg-5 col-xl-4 img_col"><img class="content_list-img lazy" data-src="'+item.previewUrl+'"></div>' : '';

            //Body Row Close
            item_html +='</div>';

            //Footer
            item_html += '<div class="row"><div class="col"><div class="content_card-footer px-2 py-1 w-100 d-flex justify-content-between">';

                item_html +='<div>';
                //Search Terms
                if (item.hasOwnProperty('terms') && item.terms.length > 0) {
                    item_html +='<span class="content_card-footer_item">Contains: <i>'+item.terms.join(', ')+'</i></span>';
                }
                item_html +='</div><div>';
                //Category
                if (isSearch && item.hasOwnProperty('category') && item.category.length > 0) {
                    item_html +='<span class="content_card-footer_item"><i class="material-icons">category</i> '+item.category+'</span>';
                }
                //tags
                if (item.hasOwnProperty('tags') && item.tags.length > 0) {
                    item_html +='<span class="content_card-footer_item"><i class="material-icons">label</i> '+item.tags.join(', ')+'</span>';
                }
                //Language
                if (item.hasOwnProperty('language') && item.language !== '') {
                    item_html +='<span class="content_card-footer_item"><i class="material-icons">language</i> '+item.language+'</span>';
                }
                //Date
                if (item.hasOwnProperty('created') && item.created !== '') {
                    let date = new Date(item.created).toLocaleDateString('en-gb').split('/').reverse().join('-');
                    item_html +='<span class="content_card-footer_item"><i class="material-icons">date_range</i> '+date+'</span>';
                }
                item_html +='</div>';


            item_html +='</div></div></div>';


        //Card Close
        item_html +='</div></a>';
    
    //Col Close
    if (col_classes) {
        item_html += '</div>';
    }

    return item_html;
}

function build_content_list_item_grid(item) {

    //Col, Card Open
    let item_html =
        '<div class="col col-sm-6 col-lg-4 my-3 grid-item">\
            <!--a href="docs/content/'+item.file+'"-->\
            <a href="doc.html?id='+item.id+'">\
            <div class="content_card card">';

                //Image Open&Close, Post Body Col Open
                if (item.hasOwnProperty('previewUrl') && item.previewUrl !== '') {
                    item_html +=
                    '<div class="card-img-top img_col">\
                        <img class="content_list-img lazy" data-src="'+item.previewUrl+'">\
                    </div>';
                }

                //Card Body Open
                item_html +=
                    '<div class="card-body">';

                    if (item.hasOwnProperty('title')) {
                        item_html += '<h5 class="card-title mb-2">'+escapeHtml(item.title)+'</h5>';
                    }

                    if ($('#content_list').data('show_metadata')) {
                        item_html += '<div class="d-flex flex-wrap mb-2">';
                        if (item.hasOwnProperty('created') && item.created !== '') {
                            let date = new Date(item.created).toLocaleDateString('en-gb').split('/').reverse().join('-');
                            item_html +='<div class="me-2"><small class="text-muted"><i class="material-icons">date_range</i> '+date+'</small></div>';
                        }
                        if (item.hasOwnProperty('authors') && item.category.indexOf('News') < 0) {
                            item_html += '<div><small class="text-wrap text-muted"><i class="material-icons">person</i> '+buildAuthorsList(item.authors)+'</small></div>';
                        }
                        item_html += '</div>';                    
                    }

                    if (item.hasOwnProperty('teaser')) {
                        item_html += '<span class="txt">'+item.teaser+'</span>';
                    }

    //Card Body, Card, Col Close
    item_html +='</div></div></a></div>';

    return item_html;

}

function build_content_list_item_light(item) {
    let item_html = '<a href="doc.html?id='+item.id+'" class="list-group-item list-group-item-action" aria-current="true">';
    
        if (item.hasOwnProperty('title') && item.title !== '') {
            item_html +='<h2 class="mb-1">'+escapeHtml(item.title)+'</h2>';
        }

        item_html += '<div class="d-flex">';
        if (item.hasOwnProperty('created') && item.created !== '') {
            let date = new Date(item.created).toLocaleDateString('en-gb').split('/').reverse().join('-');
            item_html +='<div><small class="text-muted text-nowrap"><i class="material-icons">date_range</i> '+date+'</small></div>';
        }
        if (item.hasOwnProperty('authors') && item.category.indexOf('News') < 0) {
            item_html += '<div class="ms-3"><small class="text-muted text-nowrap"><i class="material-icons">person</i> '+buildAuthorsList(item.authors)+'</small></div>';
        }
        item_html += '</div>';

        const teaserLength = 200;
        if (item.teaser.length > teaserLength) {
            item.teaser = item.teaser.slice(0,teaserLength)+'...';
        }
        item_html += '<div class="teaser mt-2">'+item.teaser+'</div>';        



    item_html += '</a>';

    return item_html;
}

function buildAuthorsList(authors, maxCount = 3) {
    let authorsCount = 0;
    let authorsHtml = '';
    $(authors).each(function(key, authorName) {
        authorsCount++;
        if (authorsCount <= maxCount) {
            authorsHtml += authorName;
            if (authorsCount < maxCount && authors.length > authorsCount) {
                authorsHtml +=', ';
            } else if (authorsCount == maxCount && authors.length > maxCount) {
                authorsHtml += ' , ...';
            }
        } else {
            return false;
        }
    });    
    return authorsHtml;
}


/* Called from the Sort-Buttons. Change the Buttons accordingly and call sort_content() */
function change_sort(btn, sort_by) {
    let new_sort_dir = '';
    if ($(btn).hasClass('active')) {
        new_sort_dir = $(btn).children('.sort_dir:not(.active)').data('sort_dir');
        $(btn).children('.sort_dir.active').removeClass('active');
        $(btn).children('.'+new_sort_dir).addClass('active');
    } else {
        $(btn).siblings('.sort_btn').removeClass('active');
        $(btn).addClass('active');

        new_sort_dir = $(btn).children('.sort_dir.active').data('sort_dir');
    }

    content_json_sorted = sort_content([], sort_by, new_sort_dir, true);
    content_json_sorted_filtered = filter_content_list_by_filter_btns(content_json_sorted);
    post_content(content_json_sorted_filtered);



}

function build_content_list_addons() {
    build_sort_bar();
    build_filter_list();
}

function build_sort_bar() {

    if ($('#sort_bar').length > 0) {

    //Any Sort-Options to be excluded?
    let sort_exclude      = $('#sort_bar').data('sort_exclude');
    if (sort_exclude !== undefined) {
        sort_exclude = sort_exclude.split(',');
    } else {
        sort_exclude = [];
    }

        let html = '';

        let sortByCreatedClass = 'active';
        if (isSearch) {
            html += `
            <button type="button" class="mx-1 btn btn-sm sort_btn active text-nowrap" onclick="change_sort(this, 'score')" title="${getTranslation('relevance')}">\
                <i class="material-icons">search</i>
                <i class="material-icons sort_dir active desc" data-sort_dir="desc">south</i>
                <i class="material-icons sort_dir asc" data-sort_dir="asc">north</i>
            </button>`;
            sortByCreatedClass = '';
        }
        if (sort_exclude.indexOf('created') < 0) {
            html += `
            <button type="button" class="mx-1 btn btn-sm sort_btn ${sortByCreatedClass} text-nowrap" onclick="change_sort(this, 'created')" title="${getTranslation('date')}">\
                <i class="material-icons">date_range</i>
                <i class="material-icons sort_dir active desc" data-sort_dir="desc">south</i>
                <i class="material-icons sort_dir asc" data-sort_dir="asc">north</i>
            </button>`;
        }
        if (sort_exclude.indexOf('title') < 0) {
            html += `
            <button type="button" class="mx-1 btn btn-sm sort_btn text-nowrap" onclick="change_sort(this, 'title')" title="${getTranslation('title')}">\
                <i class="material-icons">sort_by_alpha</i>
                <i class="material-icons sort_dir active desc" data-sort_dir="desc">south</i>
                <i class="material-icons sort_dir asc" data-sort_dir="asc">north</i>
            </button>`;
        }
        if (sort_exclude.indexOf('authors') < 0) {
            html += `
            <button type="button" class="mx-1 btn btn-sm sort_btn text-nowrap" onclick="change_sort(this, 'authors')" title="${getTranslation('authors')}">\
                <i class="material-icons">person</i>
                <i class="material-icons sort_dir active desc" data-sort_dir="desc">south</i>
                <i class="material-icons sort_dir asc" data-sort_dir="asc">north</i>
            </button>`;
        }

        html += '</span>';


        $('#sort_bar').html(html);
    }


}

function build_filter_list() {

    let filter_list_html    = `<h5 class="mx-1 d-inline-block">${getTranslation('filter')}</h5>`;
    let filter_list         = {language: {}, tags: {}, authors: {}, category: {}};

    //Any Filter Options to be excluded?
    let filter_exclude      = $('#filter_list').data('filter_exclude');
    if (filter_exclude !== undefined) {
        filter_exclude = filter_exclude.split(',');
    } else {
        filter_exclude = [];
    }

    $(content_list_global).each(function(key, item) {

        if (filter_exclude.indexOf('language') < 0 && item.hasOwnProperty('language') && item.language !== '') {
            filter_list.language[item.language] = 1;
        }
        if (filter_exclude.indexOf('tags') < 0 && item.hasOwnProperty('tags') && item.tags !== '') {
            item.tags.forEach((tag, index) => { filter_list.tags[tag] = 1 });
        }
        if (isSearch && item.category !== undefined) {
            filter_list.category[item.category] = 1;
        }
        if (filter_exclude.indexOf('authors') < 0 && item.hasOwnProperty('authors') && item.authors !== '') {
            $(item.authors).each(function(key,authorName) {
               filter_list.authors[authorName] = 1;
            });
        }
    });
    //Build Filter-List and Insert into page
    let filter_icons    = {language: 'language', tags: 'label', authors: 'person', category: 'category'};
    let filter_headings = {language: 'Language', tags: 'Tags', authors: 'Authors', category: 'Categories'};
    Object.keys(filter_list).forEach(type => {
        if (Object.keys(filter_list[type]).length > 0) {

            filter_list_html +='<span class="filter_type">';

            //If > x entries, make collapsible and collapse
            if (Object.keys(filter_list[type]).length >= 15) {
                filter_list_html +=
                `<button class="filter_type_collapse collapsed" data-bs-toggle="collapse" data-bs-target="#filters_${type}">
                    ${getTranslation(filter_headings[type].toLowerCase())}
                    <span class="material-icons">expand_less</span>
                </button>`;
                filter_list_html +='<div id="filters_'+type+'" class="collapse">';
            } else {
                filter_list_html +='<div id="filters_'+type+'">';
            }

            Object.keys(filter_list[type]).forEach(val => {
                //Set current page language as active language filter if we are looking at the Teams Page
                let lang_active = '';
                if ($('#content_list').data('category') == 'Team' && type == 'language') {
                    lang_active = getQueryParamFromURL('lang').toLowerCase() == val.toLowerCase() ? 'active' : '';
                }
                filter_list_html += '<button type="button" class="btn btn-primary '+lang_active+' filter_btn py-1 px-2 m-1 filter_'+type+'" data-bs-toggle="button" data-filter_type="'+type+'" data-filter_val="'+val+'" onclick="initialize_filter_content_list_by_filter_btns(this)"><span class="material-icons">'+filter_icons[type]+'</span> '+val+'</button>';
            
            });
            filter_list_html +='</div></span>';
        }
    });
    if ($('#filter_list').length > 0) {
        $('#filter_list').html(filter_list_html);
    }
}


function initialize_filter_content_list_by_filter_btns(btn){
    //Get content_list with currently selected sorting
    let content_list = sort_content([], window.sort_by, window.sort_dir);

    //Make language filters exclusive
    if ( $(btn).data('filter_type') == 'language' ) {
        $('.filter_language').not(btn).removeClass('active');
    }

    //Filter by filter_btns
    content_list = filter_content_list_by_filter_btns(content_list);

    //Post
    post_content(content_list);
}

function filter_content_list_by_filter_btns(content_list) {

    let content_list_filtered = [];
    //If at least 1 filter is active
    if ($('#filter_list .filter_btn.active').length > 0) {

        //Get all active filter_btns
        let active_filters = {language: [], authors: [], tags: [], category: []};
        $('#filter_list .filter_btn.active').each(function(key, filter_btn) {
            let filter_type = $(filter_btn).data('filter_type');
            let filter_val  = $(filter_btn).data('filter_val');

            active_filters[filter_type].push(filter_val);
        });

        //Filter content_list by active_filters
        $(content_list).each(function(key, item) {
            if (
                ( active_filters.language.length === 0 || active_filters.language.includes(item.language) ) &&
                ( active_filters.authors.length === 0 || active_filters.authors.every(authorName => item.authors.includes(authorName))) &&
                ( active_filters.tags.length === 0 || active_filters.tags.every(tag => item.tags.includes(tag)) ) &&
                ( active_filters.category.length === 0 || active_filters.category.every(category => item.category.includes(category)) )
            ) {
               content_list_filtered.push(item);
            }
        });

        return content_list_filtered;
    //Else return the content_list unfiltered
    } else {
        return content_list;
    }
}



function escapeHtml (string) {
    var charMap = {
        '&': '&amp;',
        '<': '&lt;',
        '>': '&gt;',
        '"': '&quot;',
        "'": '&#39;',
        '/': '&#x2F;',
        '`': '&#x60;',
        '=': '&#x3D;'
    };
    return String(string).replace(/[&<>"'`=\/]/g, function (s) {
        return charMap[s];
    });
}









/*===========================================
TMP: ARCH. SITES, MUSEUMS
============================================= */

if (baseUrl == 'https://classicmayan.org') {
    var sites_url            = baseUrl+'/portal/docs/content/fundorte.json';
    var museums_url          = baseUrl+'/portal/docs/content/museen.json';
    var iso_3166_url         = baseUrl+'/portal/docs/content/iso_3166.json';
} else {
    var sites_url            = baseUrl+'/sade/docs/content/fundorte.json';
    var museums_url          = baseUrl+'/sade/docs/content/museen.json';
    var iso_3166_url         = baseUrl+'/sade/docs/content/iso_3166.json';
}

var imgs_url = 'https://classicmayan.org/db_imgs_tmp/img/';

let sitesJSONordered   = {};
let museumsJSONordered = {};
let iso3166 = {};

function load_site_data() {
    $.getJSON(sites_url, (sitesJSON) => {
        $(sitesJSON).each((key, site) => {
            sitesJSONordered[site.id] = site;
        })
    }).done( () => {
            $.getJSON(iso_3166_url, (data) => {
                iso3166 = data;
            }).done( () => buildSiteTable() );
        }
    );
}

function load_museum_data() {
    $.getJSON(museums_url, (museumsJSON) => {
        $(museumsJSON).each((key, museum) => {
            museumsJSONordered[museum.id] = museum;
        })
    }).done( () => {
            $.getJSON(iso_3166_url, (data) => {
                iso3166 = data;
            }).done( () => buildMuseumsTable() );
        }
    );
}

function buildMuseumsTable() {

    //TODO: Move actronym to title, just like with sites

    $('#museum-tbl').bootstrapTable({
        url: museums_url,
        search: true,
        searchAlign: 'left',
        pagination: true,
        pageSize: 25,
        paginationHAlign: 'left',
        sortName: 'title',
        classes: 'table table-hover',
        paginationParts: ['pageList'],
        onClickRow: function(row, element, field) { showMuseumModal(row, element, field) },
        columns: [
            {
                field: 'old_img_src',
                title: '',
                formatter: 'museum_img_formatter',
                searchable: false,
                class: 'img-td'
            },
            {
                field: 'title',
                title: 'Name',
                formatter: 'museum_title_formatter',
                sortable: true,
                sortName: 'title'
            },
            {
                field: 'museum_state',
                title: 'Location',
                formatter: 'museum_location_formatter',
                sortable: true,
                sortName: 'museum_state'
            }
        ]
    });
}

function buildSiteTable() {

    $('#site-tbl').bootstrapTable({
        url: sites_url,
        search: true,
        searchAlign: 'left',
        pagination: true,
        pageSize: 25,
        paginationHAlign: 'left',
        sortName: 'title',
        classes: 'table table-hover',
        paginationParts: ['pageList'],
        onClickRow: function(row, element, field) { showSiteModal(row, element, field) },
        columns: [
            {
                field: 'old_img_src',
                title: '',
                formatter: 'site_img_formatter',
                searchable: false,
                class: 'img-td'
            },
            {
                field: 'title',
                title: 'Name',
                formatter: 'site_title_formatter',
                sortable: true,
                sortName: 'title'
            },
            {
                field: 'site_country',
                title: 'Location',
                formatter: 'site_location_formatter',
                sortable: true,
                sortName: 'site_state'
            }
        ]
    });



}

function showMuseumModal(row, element, field) {

    //Title
    $('#museum-name').text(row.museum_name);
    if (row.museum_acronym !== undefined) {
        $('#museum-acr').text(row.museum_acronym);
        $('#museum-acr').show();
    } else {
        $('#museum-acr').hide();
    }


    //IMG
    $('#modal-img-container').html( row.old_img_src !== undefined ? `<img src="${imgs_url+'museums/museum_'+row.id+'_thumb.jpg'}" alt="museum" />` : '<div class="site-img-dummy"><span class="material-icons">museum</span></div>' )

    //Standard Fields
    const fields = ['museum_mesoamerica_section','museum_collections','museum_state','museum_name_alt', 'museum_dissolved', 'museum_physical_address', 'museum_longitude', 'museum_latitude', 'museum_getty_id', 'museum_getty_ulan', 'museum_geonames', 'museum_postal_address', 'museum_telephone', 'museum_fax', 'museum_remarks']

    $(fields).each( (key, fieldName) => {
        let val = '';
        //Place
        if (fieldName == 'museum_state' && ( row.museum_state !== undefined || row.museum_country !== undefined )) {
            place = get_state_country(row.museum_state, row.museum_country);
            val  += (row.museum_state !== undefined ? row.museum_state+'<br/>'+place.state+', '+place.country : row.museum_country+'<br/>'+place.country);

        //Addresses
        } else if (fieldName == 'museum_physical_address' || fieldName == 'museum_postal_address') {
            if (row[fieldName] !== undefined) {
                val = row[fieldName].replace(/\n/g, "<br/>");
            }

        //Collections
        } else if (fieldName == 'museum_mesoamerica_section') {
            val = ( row[fieldName] !== undefined ?  `<a href="${row[fieldName]}" title="Website"><span class="material-icons">link</span> Website</a>` : '-' );
        } else if (fieldName == 'museum_collections') {
            val = (row[fieldName] !== undefined ? `<a href="${row[fieldName]}" title="Online Catalogue"><span class="material-icons">link</span> Online Catalogue</a>` : '-');

        } else {
            val += ( row[fieldName] !== undefined ? row[fieldName] : '-' );
        }
        $('#'+fieldName).html( val );
    });


    //Links
    const links = ['museum_website', 'museum_email', 'museum_facebook', 'museum_streetview', 'museum_twitter'];
    $(links).each( (id, fieldName) => {
        if (row[fieldName] !== undefined && row[fieldName] != '') {
            let link = (fieldName == 'museum_email' ? 'mailto:'+row[fieldName] : row[fieldName]);
            $('a#'+fieldName).attr('href', link);
            $('a#'+fieldName).show();
        } else {
            $('a#'+fieldName).hide();
            $('a#'+fieldName).attr('href', '');
        }
    })


    let modal = bootstrap.Modal.getOrCreateInstance(document.querySelector('#museum-modal'));
    modal.show();
}

function showSiteModal(row, element, field) {

    //Title
    $('#site-name').text(row.site_name);
    if (row.site_acronym !== undefined) {
        $('#site-acr').text(row.site_acronym);
        $('#site-acr').show();
    } else {
        $('#site-acr').hide();
    }

    //IMG
    $('#modal-img-container').html( row.old_img_src !== undefined ? `<img src="${imgs_url+'sites/site_'+row.id+'_thumb.jpg'}" alt="site" />` : '<div class="site-img-dummy"><span class="material-icons">public</span></div>' )

    //Standard Fields
    const fields = ['site_acronym_alt1', 'site_name_alt', 'site_geonames', 'site_getty_id', 'site_atlas_reference', 'site_latitude', 'site_longitude', 'site_state', 'site_n_texts_riese', 'site_n_texts_morley', 'site_comments', 'site_primary_source']

    $(fields).each( (key, fieldName) => {
        let val = '';
        //Place
        if (fieldName == 'site_state' && ( row.site_state !== undefined || row.site_country !== undefined )) {
            place = get_state_country(row.site_state, row.site_country);
            val  += (row.site_state !== undefined ? row.site_state+'<br/>'+place.state+', '+place.country : row.site_country+'<br/>'+place.country);

        //Comments, Sources
        } else if (fieldName == 'site_primary_source' || fieldName == 'site_comments') {
            if (row[fieldName] !== undefined) {
                val = row[fieldName].replace(/\n/g, "<br/>");
            }
        }

        else {
            val += ( row[fieldName] !== undefined ? row[fieldName] : '-' );
        }
        $('#'+fieldName).html( val );
    });

    //Links
    const links = ['site_streetview', 'site_website'];
    $(links).each( (id, fieldName) => {
        if (row[fieldName] !== undefined && row[fieldName] != '') {
            $('a#'+fieldName).attr('href', row[fieldName]);
            $('a#'+fieldName).show();
        } else {
            $('a#'+fieldName).hide();
            $('a#'+fieldName).attr('href', '');
        }
    })


    let modal = bootstrap.Modal.getOrCreateInstance(document.querySelector('#site-modal'));
    modal.show();
}


function site_title_formatter(val, row) {
    let field = '<div class="d-flex align-items-stretch">';
    field += (row.site_acronym !== undefined ? '<div><span class="badge rounded-pill bg-light text-dark row-title-pill">'+row.site_acronym+'</span> </div>' : '<div><span class="row-title-pill"> </span></div>');
    field += '<div><span class="row-title">'+val+'</span>';
    field += (row.site_name_alt !== undefined ? '<br/><span class="title-subtitle">'+row.site_name_alt+'</span></div>' : '</div>');
    return field;
}

function museum_title_formatter(val, row) {
    let field = '<div class="d-flex align-items-stretch">';
    field += (row.museum_acronym !== undefined ? '<div><span class="badge rounded-pill bg-light text-dark row-title-pill">'+row.museum_acronym+'</span> </div>' : '<div><span class="row-title-pill"> </span></div>');
    field += '<div><span class="row-title">'+val+'</span>';
    field += (row.museum_name_alt !== undefined ? '<br/><span class="title-subtitle">'+row.museum_name_alt+'</span></div>' : '</div>');
    return field;
}

function site_location_formatter(val, row) {
    let field = '<div class="d-flex align-items-stretch">';

    let pill_txt = '';
    let place    = {country: '', state: ''};
    if (row.site_state !== undefined || row.site_country !== undefined) {
        place    = get_state_country(row.site_state, row.site_country);
        pill_txt = (row.site_state !== undefined ? row.site_state : row.site_country);
    }

    field += '<div><span class="badge rounded-pill bg-light text-dark row-location-pill">'+pill_txt+'</span> ';
    field += '</div><div><span class="row-country">'+place.country+'</span>';
    field += '<br/><span class="site-row">'+place.state+'</span>';
    field +='</div></div>';

    return field;
}

function museum_location_formatter(val, row) {
    let field = '<div class="d-flex align-items-stretch">';

    let pill_txt = '';
    let place    = {country: '', state: ''};
    if (row.museum_state !== undefined || row.museum_country !== undefined) {
        place    = get_state_country(row.museum_state, row.museum_country);
        pill_txt = (row.museum_state !== undefined ? row.museum_state : row.museum_country);
    }

    field += '<div><span class="badge rounded-pill bg-light text-dark row-location-pill">'+pill_txt+'</span> ';
    field += '</div><div><span class="row-country">'+place.country+'</span>';
    field += '<br/><span class="row-state">'+place.state+'</span>';
    field += (row.museum_city !== undefined ? '<br/><span>'+row.museum_city+'</span>' : '');
    field +='</div></div>';

    return field;
}

function get_state_country(state, country) {

    let place = {country: '', state: ''};

    if (state !== undefined && state != '') {
        let split = state.split('-');
        //Country exists in iso3166?
        if (iso3166[split[0]] !== undefined) {
            place.country  = (iso3166[split[0]]['name'] === undefined ? '' : iso3166[split[0]]['name']);
            place.state    = (iso3166[split[0]]['divisions'][state] === undefined ? '' : iso3166[split[0]]['divisions'][state]);
        }
    } else if (country !== undefined && country != '') {
        place.country = iso3166[country]['name'];
        place.state   = '';
    }

    return place;
}

function site_img_formatter(val, row) {

    return (val !== undefined ? `<img src="${imgs_url+'sites/site_'+row.id+'_thumb.jpg'}" class="db-img" alt="site thumbnail" />` : '<div class="db-img-dummy"><span class="material-icons">public</span></div>');
}
function museum_img_formatter(val, row) {
    return (val !== undefined ? `<img src="${imgs_url+'museums/museum_'+row.id+'_thumb.jpg'}" class="db-img" alt="museum thumbnail" />` : '<div class="db-img-dummy"><span class="material-icons">museum</span></div>');
}

